import 'dart:io';

import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

/// try catch function
tryCatch(
  BuildContext context, {
  void Function() action,
  void Function(SocketException, StackTrace) socketException,
  void Function(FormatException, StackTrace) formatException,
  void Function(PlatformException, StackTrace) platformException,
  void Function(Exception, StackTrace) exception,
  void Function(Error, StackTrace) error,
  void Function(dynamic, StackTrace) otherCatch,
}) async {
  try {
    action();
  } on SocketException catch (e, s) {
    socketException(e, s);
  } on FormatException catch (e, s) {
    formatException(e, s);
  } on PlatformException catch (e, s) {
    platformException(e, s);
  } on Exception catch (e, s) {
    exception(e, s);
  } on Error catch (e, s) {
    error(e, s);
  } catch (e, s) {
    otherCatch(e, s);
  }
}
